/*

Arquivo:

   ST.hpp

Descrio:

   Interface de uma tabela de smbolos capaz de receber elementos
 genricos. Os elementos precisam dispor um mtodo compare, para
 que possam ser comparados com uma chave.
   Implementao com rvore binria comum.

*/

//
// Cabealhos
//
#include <stdio.h>
#include "Item.hpp"

//
// Interface
//

/* Classe */
class STable {
  /* N da rvore */
  struct node;

  /* Outros dados */
  node* head;
  int num_words;

  /* Funes privadas */
  node* insertR(node*, Item*);
  Item* searchR(node*, const char*) const;
  void deleteR(node*);
  void sortR(node*, void (*)(Item&)) const;

public:
  /* Construtores e Destrutores */
  STable() : head(NULL), num_words(0) { }
  ~STable() { deleteR(head); }

  /* Mtodos */
  void insert(Item* item) { head = insertR(head, item); }
  Item* search(const char* key) const { return searchR(head, key); }
  void sort(void (*visit)(Item&)) const { sortR(head, visit); }
};
