/*

Arquivo:

   mem.hpp

Descrio:

   Permite a criao de ponteiros seguros, que so desalocados quando saem de
 escopo.

*/

#include <stdio.h>

//
// Classes
//
template<class T>
class mem_ptr {
  T* p;
  bool released;

public:
  /* Construtores e Destrutores */
  mem_ptr() : p(NULL), released(false){ }
  mem_ptr(T* q) : p(q), released(false) { }
  ~mem_ptr() { if(!released) delete p; }

  /* Mtodos */
  void release() { released = true; }
  void lock() { released = false; }

  /* Operadores */
  void operator=(T* q)
    { p = q; released = false; }
  operator T*() { return p; }
};

template<class T>
class mem_array {
  T* p;
  bool released;

public:
  /* Construtores e Destrutores */
  mem_array() : p(NULL), released(false){ }
  mem_array(T* q) : p(q), released(false) { }
  ~mem_array() { if(!released) delete[] p; }

  /* Mtodos */
  void release() { released = true; }
  void lock() { released = false; }

  /* Operadores */
  void operator=(T* q)
    { p = q; released = false; }
  operator T*() { return p; }
};
